unit uOrderMgr;

interface
uses
  BCMA_Util;
  
type
  TLoadMOBProc = procedure(aConnectParams: WideString; aRunParams: WideString;
    var aResult: longBool);

var
  MOBDLLHandle: THandle = 0;

const
//  SHARE_DIR = '\VISTA\Common Files\';
  MOBDLLName = 'BCMAOrderCom.dll';
  LoadMOBProc: TLoadMOBProc = nil;

procedure ShowOneStepAdmin;

implementation
uses
  BCMA_Main, oCoverSheet, oInterfaces, BCMA_Common, BCMA_Objects, BCMA_Startup,
  VHA_Objects, TRpcb, Dialogs, SysUtils, Windows;

procedure LoadMOBDLL; forward;

procedure UnloadMOBDLL; forward;

procedure ShowOneStepAdmin;
var
  aAppHandle: string;
  Result: longBool;
  aConnectionParams,
    aFunctionParams: WideString;
begin
  LoadMOBDLL;
  if MOBDLLHandle <> 0 then begin
//      aAppHandle := TRPCB.GetAppHandle(RPCBrokerV);
    aAppHandle := TRPCB.GetAppHandle(BCMA_Broker);
    @LoadMOBProc := GetProcAddress(MOBDLLHandle, PAnsiChar(AnsiString('LaunchMOB')));
    if assigned(LoadMOBProc) then begin
//        aConnectionParams := aAppHandle + '^' +
//                  RPCBrokerV.Server + '^' +
//                  IntToStr(RPCBrokerV.ListenerPort) + '^' +
//                  RPCBrokerV.User.Division;
      aConnectionParams := aAppHandle + '^' +
        BCMA_Broker.Server + '^' +
        IntToStr(BCMA_Broker.ListenerPort) + '^' +
        BCMA_Broker.User.Division;

//        aFunctionParams := Patient.DFN + '^' +
//                  'CPRS' + '^' +
//                  IntToStr(User.DUZ) + '^' +
//                  '' + '^' +
//                  IntToStr(Patient.Location);
      aFunctionParams := BCMA_Patient.IEN + '^' +
        'BCMA' + '^' +
        '' + '^' + // ProviderIEN
        BCMA_User.InstructorDUZ + '^' +
        BCMA_Patient.HospitalLocationIEN;

//      LoadMOBProc(PWideChar(aConnectionParams), PWideChar(aFunctionParams), Result);
      LoadMOBProc(aConnectionParams, aFunctionParams, Result);
//        if result then frmFrame.mnuFileRefreshClick(Application);
      if result then begin
        if lstCurrentTab = ctCS then
          with TBaseInterfacedObject(BCMA_CoverSheet) as I_Anything do
            RebuildMe
        else
          frmMain.RebuildVirtualDueList(True)
      end;
    end
    else
//      MessageDLG('Can''t find function "'+'LaunchMOB'+'".',mtError,[mbok],0);
      DefMessageDLG('Can''t find function "' + 'LaunchMOB' + '".', mtError, [mbok], 0)
  end
  else
    DefMessageDLG('Can''t find library ' + MOBDLLName + '.', mtError, [mbok], 0);
  @LoadMOBProc := nil;
  UnloadMOBDLL;
end;

//CQ 15530 - Add BCMA Med Order Button Functionality as part of Clinic Orders - JCS

procedure LoadMOBDLL;
var
  MHPath: string;
begin
  if MOBDLLHandle = 0 then begin
    MHPath := GetProgramFilesPath + SHARE_DIR + MOBDLLName;
    MOBDLLHandle := LoadLibrary(PChar(MHPath));
  end;
end;

//CQ 15530 - Add BCMA Med Order Button Functionality as part of Clinic Orders - JCS

procedure UnloadMOBDLL;
begin
  if MOBDLLHandle <> 0 then begin
    FreeLibrary(MOBDLLHandle);
    MOBDLLHandle := 0;
  end;
end;

end.

